#if defined (TARGET_TEENSY3_1)
#if 0
#ifndef _MARUSOL_SENSOR_MANAGER_TILT_H_
#define _MARUSOL_SENSOR_MANAGER_TILT_H_

#include "mbed.h"
#include "ToDoQ.h"
#include "RTC_Handler.h"
#include "SensorCommonMembers.hpp"
#include "CommonTemplateRoutines.hpp"

#define BUBBLE 0
#define STOP 1
#define BEER 2
#define EMPTY 4

NAMESPACE_MARUSOLSENSORMANAGER_START

class Tilt : public ToDo, public SensorCommonMembers
{
    static Tilt *self;
    Tilt();
    uint8_t Q_newVal[10];
    uint8_t Q_oldVal[10];
    time_t Q_time[10];
    uint16_t Q_oldValDuration[10];
    Ticker tilt_tick;
    uint16_t tlt_counter1,tlt_counter2,tlt_counter3,oldcount;
    const uint16_t TLT_COUNTER;
    uint8_t oldval,newval,val;
    DigitalIn tlt_beer;
    DigitalIn tlt_bubble;
    void initQ();
    void _read_tilt();
    void putQ(uint8_t oldVal, uint8_t newVal, uint16_t duration, time_t time);
    void getQ(uint8_t *oldVal, uint8_t *newVal, uint16_t *duration, time_t *time);
    uint32_t loopTiltDelay;
public:
    DECL_GET_INSTANCE(Tilt);
    virtual void toJSON(char*);
    virtual void getBytes(uint8_t*);
    static void read_tilt();
    static void onLoop();
};

NAMESPACE_MARUSOLSENSORMANAGER_END

#endif //_MARUSOL_SENSOR_MANAGER_TILT_H_
#endif
#endif //TARGET_TEENSY3_1